#include <ctype.h>
#include <stdint.h>
#include <stdio.h>

/* Write a program that detects all strings of the form %e?x in the input,
   where '?' is a lowercase letter, and prints all letters thus appearing
   (in alphabetical order, each once). */

// This is inspired by x86 register names, called %eax, %ebx, %ecx, %edx

// mask with bit corresponding to letter set
#define CMASK(c)	((int32_t)1<<((c)-'a'))


int main(void)
{
  int32_t letset = 0;  // one bit per letter (26 < 32); or array of 26 bool
  int n = 0;		// count chars read in scanf
  for (char c[2]; scanf("%*[^%]") == 0;)	// skip to %
    if (scanf("%%e%1[a-z]x%n", c, &n), n == 4)	// match: 4 chars read
      n = 0, letset |= CMASK(*c);	// reset n, remember c[0]
  for (int c = 'a'; c <= 'z'; ++c)
    if (letset & CMASK(c)) putchar(c);
  if (letset) putchar('\n');
  return 0;
}
