#include <stdio.h>

/* Given an array a of size n, the *children* of index i are the indices
   2i+1 and 2i+2. The *height* of index i is 0 if i >= n or a[i] = 0,
   or else 1 + the larger height of its two children.
   An index is *balanced* if it has height 0 
   or if both children are balanced and their height differs by at most 1.
   Write a function that takes an integer array of size n and determines
   (returns 1 for true, 0 for false) if index 0 is balanced. */

// returns actual height or -1 if unbalanced (height irrelevant for parent)
// could have computed actual height and returned -height, but not needed
int height(int a[], unsigned n, unsigned i) 
{
  if (i >= n || a[i] == 0) return 0;
  int h1, h2;
  if ((h1 = height(a, n, 2*i+1)) == -1
      || (h2 = height(a, n, 2*i+2)) == -1) return -1;	// unbalanced
  int diff = h2 - h1;
  return diff > 0 ? (diff > 1 ? -1 : 1 + h2) : (diff < -1 ? -1 : 1 + h1);
}

int balanced(int a[], unsigned n) { return height(a, n, 0) >= 0; }

int main(void)
{
  int a[] = { 1, 1, 0, 0, 1 }; // balanced for a[2] = 1
  printf("%d\n", balanced(a, sizeof(a)/sizeof(int)));
  return 0;
}
