#include <stdint.h>
#include <stdio.h>

int b64e(int v) {	// convert value 0..63 to A-Z, a-z, 0-9, +, /
  return v < 26 ? 'A' + v :
    (v -= 26) < 26 ? 'a' + v :
    (v -= 26) < 10 ? '0' + v :
    v & 1 ? '/' : '+';	// 62 or 63: even -> +, odd -> /
}

unsigned base64enc(char s[], char d[], unsigned len)
{
  int j = 0;
  if (len > 4) {	// have room for some encoding
    len -= 4;		// last 4-char encoding must start at less
    for (int i = 0, eq = 0; s[i] && j < len; ++i) {
      uint32_t v = s[i] << 16;
      if (s[++i]) {			// at least 2 of 3 chars
	v |= s[i] << 8 | s[i+1];	// s[i+1] = 0 won't hurt
	eq = !s[++i];			// 1 = if last of three is \0
      } else eq = 2;			// pad with two equal signs
      for (int i = 4; --i >= eq; )	// 4 chars less eq signs
	d[j++] = b64e(v >> 6*i & 0x3F); 
      for (; eq; --eq) d[j++] = '=';	// at end, will exit at next loop
    }
  }
  if (len) d[j] = '\0';
  return j;
}

int main(void)
{
  char d[20];
  base64enc("ana are me", d, sizeof(d));
  puts(d);
  return 0;
}
