#include <stdio.h>
#include <stdint.h>

struct date {    // structure with bitfields
  unsigned sec : 6, min : 6;  // 6 indicates bit count
  unsigned hour : 5, day: 5;  // only integer types allowed
  unsigned month: 4;
  unsigned year: 6;
};

int main(void)
{
  struct date dt = {0, 0, 17, 19, 5, 39 };    // 17:00:00, 19.05.(1970+39)

  printf("%02u.%02u %02u:%02u\n", dt.day, dt.month, dt.hour, dt.min);
  
  printf("sizeof struct: %zu bytes\n", sizeof(struct date));
  printf("Structure has bytes: ");
  for (uint8_t *s = (uint8_t *)&dt, *end = s + sizeof(struct date); s < end; ++s)
    printf("%02x ", *s);
  putchar('\n');
  return 0;
}
