#include <math.h>
#include <stdio.h>

/* Define a structure to represent a rational number and compute (recursively)
   the nth rational approximation of a real number using a continued fraction */

typedef struct { int p; unsigned q; } rat_t;

// just print the integer expansion
void contfrac0(double x, unsigned n)
{
  for (int a; ; x = 1/(x -a)) {
    printf("%d ", a = floor(x));
    if (a == x || n-- == 0) break;
  }
  putchar('\n');
}

// the function as requested
rat_t contfrac(double x, unsigned n)
{
  int a = floor(x);
  if (a == x || n == 0) return (rat_t){ a, 1 };
  rat_t r = contfrac(1/(x-a), n - 1);
  return (rat_t){ a*r.p + r.q, r.p };
}

int main(void)
{
  double pi = acos(-1);
  contfrac0(pi, 4);
  rat_t r = contfrac(pi, 4);
  printf("pi - %d/%u = %g\n", r.p, r.q, pi - (double)r.p/r.q );
}


  
				 
