#include <stdio.h>
#include <stdlib.h>

typedef struct {
  unsigned cnt;
  float v[];	// flexible array member
} sv_t;

#define INCR	16

int cmp(const float *f1, const float *f2) {
  float d = *f1 - *f2;
  return d < 0 ? -1 : d ? 1 : 0;
}

typedef int (*cmpfn_t)(const void *, const void *);

int main(void)
{
  sv_t *t = NULL, *t1;	// pointer to structure
  unsigned cnt = 0, size = 0;
  for (float f; scanf("%f", &f) == 1; t->v[cnt++] = f)
    if (cnt == size)
      if ((t1 = realloc(t, sizeof(sv_t) + (size+=INCR)*sizeof(float)))) t = t1;
      else break;
  t->cnt = cnt;
  
  qsort (t->v, t->cnt, sizeof(float), (cmpfn_t)cmp);
  for (int i = 0; i < t->cnt; ++i)
    printf("%.2f ", t->v[i]);
  free(t);
  return 0;
}