#include <errno.h>
#include <limits.h>
#include <stdint.h>
#include <stdio.h>

void printbits(uint64_t n, unsigned k)  // least sig. k bits
{
  for (uint64_t m = (uint64_t)1 << k; m >>= 1; )
    putchar(n & m ? '1' : '0');
}

void floatparts(float f)	// prints parts of a normalized float
{
  uint32_t fbits = *(uint32_t *)&f;
  int exppart = (fbits >> 23) & 0xFF;
  if (0 < exppart && exppart < 255) {
    putchar((int32_t)fbits < 0 ? '-' : '+');
    printf("1."); printbits(fbits, 23);
    printf("*2^%d\n", exppart - 127);
  } else puts("special encoding");
}

void dblparts(double f)
{
  uint64_t fbits = *(uint64_t *)&f;
  int exppart = (fbits >> 52) & 0x7FF;
  if (0 < exppart && exppart < 2047) {
    putchar((int64_t)fbits < 0 ? '-' : '+');
    printf("1."); printbits(fbits, 52);
    printf("*2^%d\n", exppart - 1023);
  } else puts("special encoding");
}

int truncate(float f)
{
  uint32_t fbits = *(uint32_t *)&f;
  int exp = ((fbits >> 23) & 0xFF) - 127;
  if (exp < 0) return 0;	// 0 or subunit numbers
  int32_t mant = (fbits | 1 << 23) & 0xFFFFFF, res;
  if (exp <= 23) res = mant >> (23 - exp);
  else if (exp <= 30) res = fbits << (exp - 23);
  else { res = INT_MAX; puts("overflow!"); }
  return (int32_t)fbits < 0 ? -res : res;
}

int main(void)
{
  printf("%d\n", truncate(-123.45));
  // floatparts(.12);
  //dblparts(.12);
  return 0;
}
