#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>

int readnat_rc(unsigned r, int c)
{
  return isdigit(c) ? readnat_rc(10*r + (c-'0'), getchar())
    : (ungetc(c, stdin), r);
}

// skip spaces, return next char
int getcnosp(void) { int c; while (isspace(c = getchar())); return c; }
  
int expr(void);

int factor(void)	// factor ::= number | ( expr )
{
  int c = getcnosp();
  if (isdigit(c)) return readnat_rc(0, c);
  else if (c == '(') {
    int n = expr();
    if (getcnosp() == ')') return n;
    else fputs("missing )", stderr);
  } else fputs("number or ( expected", stderr);
  exit(1);	// exit from program
}

int restterm(int f1)	// f1: factor read before this
{
  int c = getcnosp();
  if (c == '*') return restterm(f1 * factor());	// continue with updated value
  if (c == '/') return restterm(f1 / factor());
  else { ungetc(c, stdin); return f1; }		// no more, return value received
}

int term(void) { return restterm(factor()); } 	// read factor, do rest

int expr(void)		// iterative, compare with term / resstterm
{
  int t1 = term();
  while (1) {		// forced exit with break
    int c = getcnosp();
    if (c == '+') t1 += term();
    else if (c == '-') t1 -= term();
    else { ungetc(c, stdin); break; }
  }
  return t1;
}

int main(void)
{
  printf("%d\n", expr());
  return 0;
}
