#include <errno.h>
#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[])
{
  if (argc != 2) {
    fprintf(stderr, "correct usage: program filename\n");
    return 1;
  }
  FILE *f = fopen(argv[1], "rb");
  if (!f) { perror("error on open"); return errno; }

  for (int c; (c = fgetc(f)) != EOF; )
    if (c == '/') {
      char lenstr[8];
      unsigned len;
      if (fscanf(f, "%7[^/]", lenstr) == 1 && !strcmp(lenstr, "Length ")
	  && fscanf(f, "%u", &len) == 1) {
	char str[7], end[10];
	fscanf(f, "%*[^s]");
	if (fscanf(f, "%6s", str) == 1 && !strcmp(str, "stream")) {
	  fseek(f, len + 2, SEEK_CUR);	// 2 for \n
	  if (fscanf(f, "%9s", end) == 1 && !strcmp(end, "endstream"))
	    printf("matching length %u\n", len);
	  else puts("length mismatch");
	}
      }
    }

  if (fclose(f)) { perror("error on close"); return errno; }
  return 0;
}
