#include <errno.h>
#include <stdio.h>

int main(int argc, char *argv[])
{
  if (argc != 2) {
    fprintf(stderr, "correct usage: program filename\n");
    return 1;
  }
  FILE *f = fopen(argv[1], "rb");
  if (!f) { perror("error on open"); return errno; }

  // code goes here

  unsigned len, n;

#define MATCH(s)  (n = 0, fscanf(f, s "%n", &n), n)

  while (fscanf(f, "%*[^/]") != EOF)
    if (MATCH("/Length") && fgetc(f) == ' ' && fscanf(f, "%u", &len) == 1) {
      fscanf(f, "%*[^s]");
      if (MATCH("stream") && !fseek(f, len + 2, SEEK_CUR) &&
	  MATCH("endstream"))
	printf("matching length %u\n", len);
      else puts("length mismatch");
    }

  if (fclose(f)) { perror("error on close"); return errno; }
  return 0;
}
