#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>

int skipspace(char **p)
{
  while (isspace(**p)) ++*p;
  return **p;
}

// return the value of a prefix expression: nat or op expr expr
// *p in/out: pointer to initial / remaining string
int expr(char **p) {
  int e, c = skipspace(p);
  if (isdigit(c)) return strtol(*p, p, 10);
  ++*p;	// advance *p over c
  switch(c) {
  case '+': return expr(p) + expr(p);	     // call order does not matter
  case '-': e = expr(p); return e - expr(p); // ensure order between calls
  case '*': return expr(p) * expr(p);
  case '/': e = expr(p); return e / expr(p);
  default: fprintf(stderr, "expected number or operator: %s\n", *p);
    exit(1);
  }
}

int main(void)
{
  char *s = "    * -5 2 + 3 4 ";
  printf("%d\n", expr(&s));
  return 0;
}
