#include <errno.h>
#include <stdio.h>

// This program just reads three integers in binary from a file

int rdint(FILE *f)	// must check ferror()/errno for success or failure
{
  int n;
  // read 1 object of sizeof(int);
  // fread needs ADDRESS as first argument
  fread(&n, sizeof(int), 1, f);		// no check here, caller must check
  return n;	// unknown if read error
}

int main(void)
{
  // usual code to open a file
  FILE *f = fopen("3ints", "rb");	// open file in binary
  if (!f) {
    perror("can't open file for writing");
    return errno;	// return error code from fopen call
  }

  // actual work: read 3 integers
  int n1 = rdint(f), n2 = rdint(f), n3 = rdint(f);
  if (ferror(f)) {
    perror("read error");
    return errno;
  } else if (feof(f)) {
    fputs("EOF on read", stderr);
    return 1;
  }
  printf("%x %x %x\n", n1, n2, n3);
  printf("%d %d %d\n", n1, n2, n3);
  
  if (fclose(f)) {	// must check for errors on closing
    perror("error closing file");
    return errno;
  }
  return 0;
}
