#include <ctype.h>
#include <stdio.h>

/* An s-expression is either a word formed of letters, or a sequence of zero
   or more s-expressions, separated by whitespace, between parantheses:
   (exp1  exp2 ... expn) . Whitespace before or after parantheses is allowed.
   Write a function that reads an s-expression from input, returning 1 (valid)
   or 0 (invalid: stop reading and print message after first error).
*/

int getnosp(void)
{
  int c;
  while (isspace(c = getchar()));
  return c;
}

int s_expr1(int c)	// c: char read; returns 1: ok, 0: error
{
  if (isalpha(c)) {	// atom = word made of letters
    while (isalpha(c = getchar()));
    if (c != EOF) ungetc(c, stdin);	// no longer part of word, put back
  } else if (c == '(') {	// ( s-expr s-expr ... s-expr )
    while ((c = getnosp()) != ')')	// done if )
      if (!s_expr1(c)) return 0;	// else must have s-expr, error if not
  } else { fprintf(stderr, "unexpected char: %c\n", c); return 0; }
  return 1;
}

int s_expr(void) { return s_expr1(getnosp()); } // pass first char

int main(void)
{
  puts(s_expr() ? "good" : "bad");
  return 0;
}
