#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Write a program that reads lines with expressions string1 op string2
   and prints their values. op is a comparison < > <= >= == != producing 1 or 0,
   or concatenation written ++. Strings have at most 40 chars, no whitespace
   or operators. Other whitespace is optional. */

// make int from two chars to use a single comparison for resulting value

#define OP(c1, c2)	(c1<<8|c2)

void _Noreturn fatal(char *s) { fputs(s, stderr); exit(1); }

int skipspace() { return scanf("%*[\t\v\f\r ]"); } // no newlines

void readstring(char *s) { 
  if (scanf("%40[^\t\n\v\f\r !+<=>]", s) != 1) fatal("bad string\n");
  skipspace();
}

int main(void)
{
  for(char s1[41], s2[41]; skipspace() != EOF;) { // while still something
    readstring(s1);
    int c1 = getchar(), c2 = getchar();
    if (c2 != '=' && c2 != '+') ungetc(c2, stdin), c2 = ' ';
    skipspace();
    readstring(s2);
    int op = OP(c1,c2);
    if (op == OP('+','+')) printf("%s%s", s1, s2);
    else {
      int cr = strcmp(s1, s2), br;	// comparison and boolean result
      if (op == OP('<',' ')) br = cr < 0;
      else if (op == OP('>',' ')) br = cr > 0;
      else if (op == OP('<','=')) br = cr <= 0;
      else if (op == OP('>','=')) br = cr >= 0;
      else if (op == OP('=','=')) br = cr == 0;
      else if (op == OP('!','=')) br = cr != 0;
      else fatal("bad operator\n");
      putchar(br + '0');
    }
    putchar('\n');
    if (getchar() != '\n') fatal("bad end of line\n");
  }
}
