#include <stdio.h>
#include <stdlib.h>

// prints all whitespace-separated ints from s
void printallints(char *s)
{
  char *old;	// save old s on call; pass address of s to update with end 
  long n;
  while (n = strtol(old = s, &s, 10), s != old)
    printf("%ld\n", n);
}

// in: *p is start of string
// out: *p is end of string (start of unprocessed part)
long sumallints(char **p)
{
  char *old;	// save old value of string (*p) on call
  long sum = 0;
  do sum += strtol(old = *p, p, 10);	// no problem if adding 0
  while (*p != old);
  return sum;
}

int main(int argc, char *argv[])
{
  if (argc == 2) {	// run with numbers between quotes: "   123 -56  42xyz"
    printf("%p: %s\n", argv[1], argv[1]);
    printallints(argv[1]);
    printf("sum: %ld\n", sumallints(&argv[1]));  // argv[1] is char *
    printf("%p: %s\n", argv[1], argv[1]);
  }
  return 0;
}
