#include <stdio.h>
#include <stdlib.h>

/* Read numbers until EOF, store them using a vector of pointers to vectors.
   A vector ends with a 0 in the input (should be stored) */

#define INCR	32

int *readvect(void)	// read one vector until 0 or EOF, return pointer
{
  int *v = NULL, *tmp;
  unsigned cnt = 0, size = 0;
  for (int n; scanf("%d", &n) == 1 && n; v[cnt++] = n)
    if (cnt == size)	// alloc one extra for final 0
      if ((tmp = realloc(v, ((size += INCR) + 1) * sizeof(int)))) v = tmp;
      else break;
  if (v) v[cnt] = 0;	// terminate with 0
  return v;	// optional: realloc(v, (cnt+1)*sizeof(int))
}

int **readall(void)	// read all, return NULL-terminated vector of pointers
{
  int **t = NULL, **tmp;
  unsigned cnt = 0, size = 0;
  for (int *v; (v = readvect()); t[cnt++] = v)
    if (cnt == size)	// alloc one extra for final NULL
      if ((tmp = realloc(t, ((size += INCR) + 1) * sizeof(int *)))) t = tmp;
      else break;
  if (t) t[cnt] = NULL;	// mark end of vector
  return t;	// optional: realloc(t, (cnt+1)*sizeof(int *))
}

void printvect(int *v) {
  while (*v) printf("%d ", *v++);
  puts("0");
}

void printall(int **t) { while (*t) printvect(*t++); }

void freevects(int **t) { while (*t) free(*t++); }

int main(void)
{
  int **t = readall();
  if (t) {
    printall(t);
    freevects(t);	// vectors of ints
    free(t);		// vector of pointers
  }
  return 0;
}
