#include <ctype.h>
#include <stdio.h>

// count words to EOF. words are strings of non-whitespace chars

unsigned wc1(void)	// option 1: state machine
{
  unsigned cnt = 0;
  int c, in = 0; // in a word, initially false
  while ((c = getchar()) != EOF)
    if (isspace(c)) in = 0;
    else if (!in) { ++cnt; in = 1; }
  return cnt;
}

unsigned wc1b(void)	// option 1: state machine, just 1 test
{
  unsigned cnt = 0;
  for (int c, out = 1; (c = getchar()) != EOF; )
    if (isspace(c)) out = 1;
    else { cnt += out; out = 0; }
  return cnt;
}

unsigned wc2(void)	// option 2: either word or individual space (ignore)
{
  int c;
  unsigned cnt = 0;
  while ((c = getchar()) != EOF)
    if (!isspace(c)) {
      ++cnt;
      while (!isspace(c = getchar()) && c != EOF);
      // don't need to deal with c isspace() after
    } // else isspace(c) uninteresting
  return cnt;
}

unsigned wc3(void)	// option 3: repeat: spaces + word
{
  int c;
  unsigned cnt = 0;
  while (1) {
    while (isspace(c = getchar()));
    if (c == EOF) break;
    ++cnt;
    while (!isspace(c = getchar()) && c != EOF);
  }
  return cnt;
}

int main(void)
{
  printf ("%u\n", wc3());
  return 0;
}
