#include <errno.h>
#include <stdio.h>

// This program just writes three integers in binary to a file

int wrint(int n, FILE *f)	// 1 on success, 0 on error
{
  // write 1 object of sizeof(int); can also pass unsigned n since same size
  // fwrite needs ADDRESS as first argument
  return fwrite(&n, sizeof(int), 1, f);	// how many objects written
}

int main(void)
{
  FILE *f = fopen("3ints", "wb");	// open file in binary
  if (!f) {
    perror("can't open file for writing");
    return errno;	// return error code from fopen call
  }

  // actual work: write 3 integers
  if (!wrint(5, f) || !wrint(0xCAFEBABE, f) || !wrint(-6, f)) {
    perror("error on writing");
    return errno;
  }
  
  if (fclose(f)) {	// must check for errors on closing
    perror("error closing file");
    return errno;
  }
  return 0;
}
